Ginkgo: gko::preconditioner::Sor< ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::preconditioner::Sor< ValueType, IndexType > Class Template Reference
Linear Operators » Preconditioners

This class generates the (S)SOR preconditioner. More...

`#include <ginkgo/core/preconditioner/sor.hpp>`

Inheritance diagram for gko::preconditioner::Sor< ValueType, IndexType >:
[legend]
Collaboration diagram for gko::preconditioner::Sor< ValueType, IndexType >:
[legend]

## Classes
struct | parameters_type

## Public Types
using | value_type = ValueType
using | index_type = IndexType
using | composition_type = Composition<ValueType>
Public Types inherited from gko::EnablePolymorphicAssignment< Sor< default_precision, int32 > >
using | result_type

## Public Member Functions
const parameters_type & | get_parameters ()
| Returns the parameters used to construct the factory.
const parameters_type & | get_parameters () const
| Returns the parameters used to construct the factory.
std::unique_ptr< composition_type > | generate (std::shared_ptr< const LinOp > system_matrix) const
| Creates a new product from the given components.
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Sor< default_precision, int32 > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Static Public Member Functions
static parameters_type | build ()
| Creates a new parameter_type to set up the factory.
static parameters_type | parse (const config::pnode &config, const config::registry &context, const config::type_descriptor &td_for_child=config::make_type_descriptor< ValueType, IndexType >())

## Friends
class | EnablePolymorphicObject< Sor, LinOpFactory >
class | enable_parameters_type< parameters_type, Sor >

## Detailed Description

template<typename ValueType = default_precision, typename IndexType = int32>
class gko::preconditioner::Sor< ValueType, IndexType >

This class generates the (S)SOR preconditioner.

The SOR preconditioner starts from a splitting of the the matrix into , where contains all entries below the diagonal, and contains all entries above the diagonal. The application of the preconditioner is then defined as solving with

is known as the relaxation factor. The preconditioner can be made symmetric, leading to the SSOR preconitioner. Here, is defined as

A detailed description can be found in Iterative Methods for Sparse Linear Systems (Y. Saad) ch. 4.1.

This class is a factory, which will only generate the preconditioner. The resulting LinOp will represent the application of .

Template Parameters

  ValueType | The value type of the internally used CSR matrix
  IndexType | The index type of the internally used CSR matrix

## Member Function Documentation

## ◆ generate()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< composition_type > gko::preconditioner::Sor< ValueType, IndexType >::generate | ( | std::shared_ptr< const LinOp > | system_matrix | ) | const

Creates a new product from the given components.

The method will create an ComponentsType object from the arguments of this method, and pass it to the generate_impl() function which will create a new AbstractProductType.

Template Parameters

  Args | types of arguments passed to the constructor of ComponentsType

Parameters

  args | arguments passed to the constructor of ComponentsType

Returns
  an instance of AbstractProductType

Note
  This function overrides the default LinOpFactory::generate to return a Factorization instead of a generic LinOp, which would need to be cast to Factorization again to access its factors. It is only necessary because smart pointers aren't covariant.

## ◆ get_parameters() [1/2]

template<typename ValueType = default_precision, typename IndexType = int32>

const parameters_type & gko::preconditioner::Sor< ValueType, IndexType >::get_parameters | ( |  | ) |
| inline

Returns the parameters used to construct the factory.

Returns
  the parameters used to construct the factory.

## ◆ get_parameters() [2/2]

template<typename ValueType = default_precision, typename IndexType = int32>

const parameters_type & gko::preconditioner::Sor< ValueType, IndexType >::get_parameters | ( |  | ) | const
| inline

Returns the parameters used to construct the factory.

Returns
  the parameters used to construct the factory.

The documentation for this class was generated from the following file:

- ginkgo/core/preconditioner/sor.hpp